/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.jiuqi.sql.DBException
 *  com.jiuqi.sql.FieldInfo
 *  com.jiuqi.sql.FieldInfoList
 *  com.jiuqi.sql.InputDataSet
 *  com.jiuqi.sql.InputDataSetMetaData
 *  com.jiuqi.sql.InputRecordBuffer
 *  com.jiuqi.util.MemStream
 */
package com.jiuqi.sql.impl;

import com.jiuqi.sql.DBException;
import com.jiuqi.sql.FieldInfo;
import com.jiuqi.sql.FieldInfoList;
import com.jiuqi.sql.InputDataSet;
import com.jiuqi.sql.InputDataSetMetaData;
import com.jiuqi.sql.InputRecordBuffer;
import com.jiuqi.sql.impl.DBaseFieldHeader;
import com.jiuqi.sql.impl.DBaseFileHeader;
import com.jiuqi.sql.impl.DBaseFileTail;
import com.jiuqi.sql.impl.DBaseInputDataSetMetaData;
import com.jiuqi.sql.impl.DBaseInputRecordBuffer;
import com.jiuqi.util.MemStream;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;

public class DBaseInputDataSet
extends InputDataSet {
    private InputStream stream;
    private DBaseFileHeader header = new DBaseFileHeader();
    private DBaseFileTail tail = new DBaseFileTail();
    private DBaseInputRecordBuffer buffer;
    private FieldInfoList infoList;

    private int getFieldType(char dataType) {
        int result = dataType;
        switch (dataType) {
            case 67: 
            case 70: 
            case 87: {
                result = 6;
                break;
            }
            case 76: {
                result = 1;
                break;
            }
            case 43: {
                result = 7;
                break;
            }
            case 37: 
            case 79: {
                result = 3;
                break;
            }
            case 65: 
            case 73: 
            case 82: {
                result = 5;
                break;
            }
            case 64: 
            case 68: {
                result = 2;
                break;
            }
            case 90: {
                result = 8;
            }
        }
        return result;
    }

    public DBaseInputDataSet(InputStream inStream) {
        this.stream = inStream;
    }

    public DBaseInputDataSet(byte[] data) {
        this(new ByteArrayInputStream(data));
    }

    public FieldInfoList getFields() {
        return this.infoList;
    }

    public InputDataSetMetaData getMetaData() throws DBException {
        return new DBaseInputDataSetMetaData(this.infoList);
    }

    protected boolean getNextRecord(InputRecordBuffer buffer) throws DBException {
        return buffer.readRecord(this.stream);
    }

    protected void initFields(FieldInfoList fieldInfos) throws DBException {
        fieldInfos.clear();
        try {
            this.header.readFromStream(this.stream);
            boolean supportText = this.header.ver == -115;
            int fieldCount = (this.header.structDefLen - 68 - 1) / 50;
            if (fieldCount == 0) {
                throw new DBException("Not Field Define！");
            }
            DBaseFieldHeader fieldHeader = new DBaseFieldHeader();
            int fieldOffset = 0;
            int i = 0;
            while (i < fieldCount) {
                fieldHeader.readFromStream(this.stream);
                FieldInfo fieldInfo = fieldInfos.add();
                fieldInfo.name = fieldHeader.fieldName;
                fieldInfo.incValue = fieldHeader.incValue;
                fieldInfo.offset = fieldOffset;
                fieldInfo.size = fieldHeader.fieldLength;
                fieldInfo.decimal = fieldHeader.scale;
                fieldInfo.type = this.getFieldType(fieldHeader.dataType);
                fieldOffset = supportText && fieldInfo.type == 6 ? (fieldOffset += 4) : (fieldOffset += fieldHeader.fieldLength);
                ++i;
            }
            if (fieldOffset != this.header.recLength - 1) {
                throw new DBException("Field Define Infomation Error");
            }
            this.stream.read();
            this.stream.mark(0);
            this.stream.skip(this.header.recCount * (long)this.header.recLength + 1L);
            this.tail.readFromStream(this.stream);
            this.buffer = new DBaseInputRecordBuffer(this.header.recLength - 1, supportText, this.tail);
            this.infoList = fieldInfos;
            this.stream.reset();
        }
        catch (IOException ex) {
            DBException dbe = new DBException();
            dbe.setStackTrace(ex.getStackTrace());
            throw dbe;
        }
    }

    protected InputRecordBuffer internalOpen() throws DBException {
        return this.buffer;
    }

    protected void internalClose() throws DBException {
        this.buffer = null;
    }

    public void first() throws DBException {
        try {
            this.stream.reset();
        }
        catch (Exception ex) {
            throw new DBException((Throwable)ex);
        }
    }

    public static void main(String[] args) throws Exception {
        MemStream s = new MemStream();
        s.loadFromFile("d:\\1.dbf");
        ByteArrayInputStream as = new ByteArrayInputStream(s.getBytes());
        DBaseInputDataSet dataset = new DBaseInputDataSet(as);
        dataset.open();
        while (dataset.next()) {
            System.out.print(dataset.getBoolean(1));
            if (dataset.wasNull()) {
                System.out.print("[ISNULL]");
            }
            System.out.print("\t");
            System.out.print(dataset.getDouble(2));
            if (dataset.wasNull()) {
                System.out.print("[ISNULL]");
            }
            System.out.print("\t");
            System.out.print(dataset.getInt(3));
            if (dataset.wasNull()) {
                System.out.print("[ISNULL]");
            }
            System.out.print("\t");
            System.out.print(dataset.getString(4));
            if (dataset.wasNull()) {
                System.out.print("[ISNULL]");
            }
            System.out.print("\t");
            System.out.print(dataset.getLong(5));
            if (dataset.wasNull()) {
                System.out.print("[ISNULL]");
            }
            System.out.println("\t");
        }
        System.out.println("OK");
    }
}

